gtkmm: Gtk::UIManager Class Reference

gtkmm 3.22.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::UIManager Class Reference

Constructing menus and toolbars from an XML description. More...

`#include <gtkmm/uimanager.h>`

Inheritance diagram for Gtk::UIManager:
[legend]

## Public Types
typedef guint | ui_merge_id
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Public Member Functions
| UIManager (UIManager&& src) noexcept
UIManager& | operator= (UIManager&& src) noexcept
| ~UIManager () noexceptoverride
GtkUIManager* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkUIManager* | gobj () const
| Provides access to the underlying C GObject. More...
GtkUIManager* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_add_tearoffs (bool add_tearoffs=true)
| Sets the “add_tearoffs” property, which controls whether menus generated by this Gtk::UIManager will have tearoff menu items. More...
bool | get_add_tearoffs () const
| Returns whether menus generated by this Gtk::UIManager will have tearoff menu items. More...
void | insert_action_group (const Glib::RefPtr< ActionGroup >& action_group, int pos=0)
| Inserts an action group into the list of action groups associated with manager. More...
void | remove_action_group (const Glib::RefPtr< ActionGroup >& action_group)
| Removes an action group from the list of action groups associated with manager. More...
std::vector< Glib::RefPtr< ActionGroup > > | get_action_groups ()
| Returns the list of action groups associated with manager. More...
std::vector< Glib::RefPtr< const ActionGroup > > | get_action_groups () const
| Returns the list of action groups associated with manager. More...
Glib::RefPtr< AccelGroup > | get_accel_group ()
| Returns the Gtk::AccelGroup associated with manager. More...
Glib::RefPtr< const AccelGroup > | get_accel_group () const
| Returns the Gtk::AccelGroup associated with manager. More...
Widget* | get_widget (const Glib::ustring& path)
| Looks up a widget by following a path. More...
const Widget* | get_widget (const Glib::ustring& path) const
| Looks up a widget by following a path. More...
std::vector< Widget* > | get_toplevels (UIManagerItemType types)
| Obtains a list of all toplevel widgets of the requested types. More...
std::vector< const Widget* > | get_toplevels (UIManagerItemType types) const
| Obtains a list of all toplevel widgets of the requested types. More...
Glib::RefPtr< Action > | get_action (const Glib::ustring& path)
| Looks up an action by following a path. More...
Glib::RefPtr< const Action > | get_action (const Glib::ustring& path) const
| Looks up an action by following a path. More...
ui_merge_id | add_ui_from_string (const Glib::ustring& buffer)
| Parses a string containing a UI definition and merges it with the current contents. More...
ui_merge_id | add_ui_from_file (const Glib::ustring& filename)
| Parses a file containing a [UI definition][XML-UI] and merges it with the current contents of manager. More...
ui_merge_id | add_ui_from_resource (const Glib::ustring& resource_path)
| Parses a resource file containing a [UI definition][XML-UI] and merges it with the current contents of manager. More...
void | add_ui (ui_merge_id merge_id, const Glib::ustring& path, const Glib::ustring& name, const Glib::ustring& action, UIManagerItemType type=Gtk::UI_MANAGER_AUTO, bool top=true)
| Adds a UI element to the current contents of self. More...
void | add_ui_separator (ui_merge_id merge_id, const Glib::ustring& path, const Glib::ustring& name="", UIManagerItemType type=Gtk::UI_MANAGER_AUTO, bool top=true)
| Adds a separator UI element to the current contents. More...
void | remove_ui (ui_merge_id merge_id)
| Unmerges the part of manager's content identified by merge_id. More...
Glib::ustring | get_ui () const
| Creates a [UI definition][XML-UI] of the merged UI. More...
void | ensure_update ()
| Makes sure that all pending updates to the UI have been completed. More...
ui_merge_id | new_merge_id ()
| Returns an unused merge id, suitable for use with gtk_ui_manager_add_ui(). More...
Glib::SignalProxy< void, Widget* > | signal_add_widget ()
Glib::SignalProxy< void > | signal_actions_changed ()
Glib::SignalProxy< void, const Glib::RefPtr< Action >&, Widget* > | signal_connect_proxy ()
Glib::SignalProxy< void, const Glib::RefPtr< Action >&, Widget* > | signal_disconnect_proxy ()
Glib::SignalProxy< void, const Glib::RefPtr< Action >& > | signal_pre_activate ()
Glib::SignalProxy< void, const Glib::RefPtr< Action >& > | signal_post_activate ()
Glib::PropertyProxy< bool > | property_add_tearoffs ()
| The "add-tearoffs" property controls whether generated menus have tearoff menu items. More...
Glib::PropertyProxy_ReadOnly< bool > | property_add_tearoffs () const
| The "add-tearoffs" property controls whether generated menus have tearoff menu items. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_ui () const
| An XML string describing the merged UI. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< UIManager > | create ()

## Protected Member Functions
| UIManager ()
virtual void | on_add_widget (Widget* widget)
| This is a default handler for the signal signal_add_widget(). More...
virtual void | on_actions_changed ()
| This is a default handler for the signal signal_actions_changed(). More...
virtual void | on_connect_proxy (const Glib::RefPtr< Action >& action, Widget* widget)
| This is a default handler for the signal signal_connect_proxy(). More...
virtual void | on_disconnect_proxy (const Glib::RefPtr< Action >& action, Widget* widget)
| This is a default handler for the signal signal_disconnect_proxy(). More...
virtual void | on_pre_activate (const Glib::RefPtr< Action >& action)
| This is a default handler for the signal signal_pre_activate(). More...
virtual void | on_post_activate (const Glib::RefPtr< Action >& action)
| This is a default handler for the signal signal_post_activate(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexceptoverride
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::UIManager > | wrap (GtkUIManager* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

Constructing menus and toolbars from an XML description.

A Gtk::UIManager constructs a user interface (menus and toolbars) from one or more UI definitions, which reference actions from one or more action groups.

UI Definitions

The UI definitions are specified in an XML format which can be roughly described by the following DTD.

<!ELEMENT ui (menubar|toolbar|popup|accelerator)* >
<!ELEMENT menubar (menuitem|separator|placeholder|menu)* >
<!ELEMENT menu (menuitem|separator|placeholder|menu)* >
<!ELEMENT popup (menuitem|separator|placeholder|menu)* >
<!ELEMENT toolbar (toolitem|separator|placeholder)* >
<!ELEMENT placeholder (menuitem|toolitem|separator|placeholder|menu)* >
<!ELEMENT menuitem EMPTY >
<!ELEMENT toolitem (menu?) >
<!ELEMENT separator EMPTY >
<!ELEMENT accelerator EMPTY >
<!ATTLIST menubar name #IMPLIED
action #IMPLIED >
<!ATTLIST toolbar name #IMPLIED
action #IMPLIED >
<!ATTLIST popup name #IMPLIED
action #IMPLIED >
<!ATTLIST placeholder name #IMPLIED
action #IMPLIED >
<!ATTLIST separator name #IMPLIED
action #IMPLIED
expand (true|false) #IMPLIED >
<!ATTLIST menu name #IMPLIED
action #REQUIRED
position (top|bot) #IMPLIED >
<!ATTLIST menuitem name #IMPLIED
action #REQUIRED
position (top|bot) #IMPLIED >
<!ATTLIST toolitem name #IMPLIED
action #REQUIRED
position (top|bot) #IMPLIED >
<!ATTLIST accelerator name #IMPLIED
action #REQUIRED >

There are some additional restrictions beyond those specified in the DTD, e.g. every toolitem must have a toolbar in its anchestry and every menuitem must have a + menubar or popup in its anchestry. Since a GMarkup parser is used to parse the UI description, it must not only be valid XML, but valid GMarkup.

If a name is not specified, it defaults to the action. If an action is not specified either, the element name is used. The name and action attributes must not contain '/' characters after parsing (since that would mess up path lookup) and must be usable as XML attributes when enclosed in doublequotes, thus they must not '"' characters or references to the " entity.

Example: UI Definition
  <ui>
  <menubar>
  <menu name="FileMenu" action="FileMenuAction">
  <menuitem name="New" action="New2Action" />
  <placeholder name="FileMenuAdditions" />
  </menu>
  <menu name="JustifyMenu" action="JustifyMenuAction">
  <menuitem name="Left" action="justify-left"/>
  <menuitem name="Centre" action="justify-center"/>
  <menuitem name="Right" action="justify-right"/>
  <menuitem name="Fill" action="justify-fill"/>
  </menu>
  </menubar>
  <toolbar action="toolbar1">
  <placeholder name="JustifyToolItems">
  <separator/>
  <toolitem name="Left" action="justify-left"/>
  <toolitem name="Centre" action="justify-center"/>
  <toolitem name="Right" action="justify-right"/>
  <toolitem name="Fill" action="justify-fill"/>
  <separator/>
  </placeholder>
  </toolbar>
  </ui>

The constructed widget hierarchy is very similar to the element tree of the XML, with the exception that placeholders are merged into their parents. The correspondence of XML elements to widgets should be almost obvious:

- menubar a Gtk::MenuBar
- toolbar a Gtk::Toolbar
- popup a toplevel Gtk::Menu
- menu a Gtk::Menu attached to a menuitem
- menuitem a Gtk::MenuItem subclass, the exact type depends on the action
- toolitem a Gtk::ToolItem subclass, the exact type depends on the action. Note that toolitem elements may contain a menu element, but only if their associated action specifies a Gtk::MenuToolButton as proxy.
- separator a Gtk::SeparatorMenuItem or Gtk::SeparatorToolItem
- accelerator a keyboard accelerator

The "position" attribute determines where a constructed widget is positioned wrt. to its siblings in the partially constructed tree. If it is "top", the widget is prepended, otherwise it is appended.

UI Merging

The most remarkable feature of Gtk::UIManager is that it can overlay a set of menuitems and toolitems over another one, and demerge them later.

Merging is done based on the names of the XML elements. Each element is identified by a path which consists of the names of its anchestors, separated by slashes. For example, the menuitem named "Left" in the example above has the path /ui/menubar/JustifyMenu/Left and the toolitem with the same name has path /ui/toolbar1/JustifyToolItems/Left.

Accelerators

Every action has an accelerator path. Accelerators are installed together with menuitem proxies, but they can also be explicitly added with <accelerator> elements in the UI definition. This makes it possible to have accelerators for actions even if they have no visible proxies.

Smart Separators

The separators created by Gtk::UIManager are "smart", i.e. they do not show up in the UI unless they end up between two visible menu or tool items. Separators which are located at the very beginning or end of the menu or toolbar containing them, or multiple separators next to each other, are hidden. This is a useful feature, since the merging of UI elements from multiple sources can make it hard or impossible to determine in advance whether a separator will end up in such an unfortunate position.

For separators in toolbars, you can set expand="true" to turn them from a small, visible separator to an expanding, invisible one. Toolitems following an expanding separator are effectively right-aligned.

Empty Menus

Submenus pose similar problems to separators inconnection with merging. It is impossible to know in advance whether they will end up empty after merging. Gtk::UIManager offers two ways to treat empty submenus:

- make them disappear by hiding the menu item they're attached to
- add an insensitive "Empty" item

The behaviour is chosen based on the "hide_if_empty" property of the action to which the submenu is associated.

Since gtkmm 2.4:

Deprecated:
  Use Gtk::Builder instead.
  The menus and toolbars examples in the Programming with gtkmm 3 book show how to construct menus and toolbars with Gtk::Builder.

## Member Typedef Documentation

typedef guint Gtk::UIManager::ui_merge_id

## Constructor & Destructor Documentation

Gtk::UIManager::UIManager | ( | UIManager&& | src | ) |
| noexcept

Gtk::UIManager::~UIManager | ( |  | ) |
| overridenoexcept

Gtk::UIManager::UIManager | ( |  | ) |
| protected

## Member Function Documentation

void Gtk::UIManager::add_ui | ( | ui_merge_id | merge_id,
|  | const Glib::ustring & | path,
|  | const Glib::ustring & | name,
|  | const Glib::ustring & | action,
|  | UIManagerItemType | type = `Gtk::UI_MANAGER_AUTO`,
|  | bool | top = `true`
| ) |  |

Adds a UI element to the current contents of self.

If type is Gtk::UI_MANAGER_AUTO, GTK+ inserts a menuitem, toolitem or separator if such an element can be inserted at the place determined by path. Otherwise type must indicate an element that can be inserted at the place determined by path.

see add_ui_separator().

Since gtkmm 2.4:

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Parameters

  merge_id | The merge id for the merged UI, see gtk_ui_manager_new_merge_id().
  path | A path.
  name | The name for the added UI element.
  action | The name of the action to be proxied, if this is not a separator.
  type | The type of UI element to add.
  top | If `true`, the UI element is added before its siblings, otherwise it is added after its siblings.

ui_merge_id Gtk::UIManager::add_ui_from_file | ( | const Glib::ustring & | filename | ) |

Parses a file containing a [UI definition][XML-UI] and merges it with the current contents of manager.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  Use Gtk::Builder::add_from_file() instead.

Parameters

  filename | The name of the file to parse.

Returns
  The merge id for the merged UI. The merge id can be used to unmerge the UI with gtk_ui_manager_remove_ui(). If an error occurred, the return value is 0.

ui_merge_id Gtk::UIManager::add_ui_from_resource | ( | const Glib::ustring & | resource_path | ) |

Parses a resource file containing a [UI definition][XML-UI] and merges it with the current contents of manager.

Since gtkmm 3.4:

Deprecated: 3.10

Deprecated:
  Use Gtk::Builder::add_from_resource() instead.

Parameters

  resource_path | The resource path of the file to parse.

Returns
  The merge id for the merged UI. The merge id can be used to unmerge the UI with gtk_ui_manager_remove_ui(). If an error occurred, the return value is 0.

ui_merge_id Gtk::UIManager::add_ui_from_string | ( | const Glib::ustring & | buffer | ) |

Parses a string containing a UI definition and merges it with the current contents.

An enclosing <ui> element is added if it is missing.

Parameters

  buffer | the string to parse

Returns
  The merge id for the merged UI. The merge id can be used to unmerge the UI with remove_ui(). If an error occurred, the return value is 0.

Exceptions

  exception |

Since gtkmm 2.4:

Deprecated:
  Use Gtk::Builder::add_from_string() instead.

void Gtk::UIManager::add_ui_separator | ( | ui_merge_id | merge_id,
|  | const Glib::ustring & | path,
|  | const Glib::ustring & | name = `""`,
|  | UIManagerItemType | type = `Gtk::UI_MANAGER_AUTO`,
|  | bool | top = `true`
| ) |  |

Adds a separator UI element to the current contents.

If type is Gtk::UI_MANAGER_AUTO, GTK+ inserts a menuitem, toolitem or separator if such an element can be inserted at the place determined by path . Otherwise type must indicate an element that can be inserted at the place determined by path.

See also
  add_ui().

Since gtkmm 2.4:

Parameters

  merge_id | The merge id for the merged UI, see gtk_ui_manager_new_merge_id().
  path | A path.
  name | The name for the added UI element.
  type | The type of UI element to add.
  top | If `true`, the UI element is added before its siblings, otherwise it is added after its siblings.

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

static Glib::RefPtr<UIManager> Gtk::UIManager::create | ( |  | ) |
| static

void Gtk::UIManager::ensure_update | ( |  | ) |

Makes sure that all pending updates to the UI have been completed.

This may occasionally be necessary, since Gtk::UIManager updates the UI in an idle function. A typical example where this function is useful is to enforce that the menubar and toolbar have been added to the main window before showing it:

[C example ellipted]

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Glib::RefPtr<AccelGroup> Gtk::UIManager::get_accel_group | ( |  | ) |

Returns the Gtk::AccelGroup associated with manager.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  Use Gio::ActionGroup and the accelerator group on an associated Gtk::Menu instead.

Returns
  The Gtk::AccelGroup.

Glib::RefPtr<const AccelGroup> Gtk::UIManager::get_accel_group | ( |  | ) | const

Returns the Gtk::AccelGroup associated with manager.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  Use Gio::ActionGroup and the accelerator group on an associated Gtk::Menu instead.

Returns
  The Gtk::AccelGroup.

Glib::RefPtr<Action> Gtk::UIManager::get_action | ( | const Glib::ustring & | path | ) |

Looks up an action by following a path.

See gtk_ui_manager_get_widget() for more information about paths.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Parameters

  path | A path.

Returns
  The action whose proxy widget is found by following the path, or `nullptr` if no widget was found.

Glib::RefPtr<const Action> Gtk::UIManager::get_action | ( | const Glib::ustring & | path | ) | const

Looks up an action by following a path.

See gtk_ui_manager_get_widget() for more information about paths.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Parameters

  path | A path.

Returns
  The action whose proxy widget is found by following the path, or `nullptr` if no widget was found.

std::vector< Glib::RefPtr<ActionGroup> > Gtk::UIManager::get_action_groups | ( |  | ) |

Returns the list of action groups associated with manager.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  Use Gtk::Widget::list_action_prefixes() and Gtk::Widget::get_action_group() instead.

Returns
  A List of action groups. The list is owned by GTK+ and should not be modified.

std::vector< Glib::RefPtr<const ActionGroup> > Gtk::UIManager::get_action_groups | ( |  | ) | const

Returns the list of action groups associated with manager.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  Use Gtk::Widget::list_action_prefixes() and Gtk::Widget::get_action_group() instead.

Returns
  A List of action groups. The list is owned by GTK+ and should not be modified.

bool Gtk::UIManager::get_add_tearoffs | ( |  | ) | const

Returns whether menus generated by this Gtk::UIManager will have tearoff menu items.

Since gtkmm 2.4:

Deprecated: 3.4: Tearoff menus are deprecated and should not be used in newly written code.

Deprecated:
  Tearoff menus are deprecated and should not be used in newly written code.

Returns
  Whether tearoff menu items are added.

std::vector<Widget*> Gtk::UIManager::get_toplevels | ( | UIManagerItemType | types | ) |

Obtains a list of all toplevel widgets of the requested types.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Parameters

  types | Specifies the types of toplevel widgets to include. Allowed types are Gtk::UI_MANAGER_MENUBAR, Gtk::UI_MANAGER_TOOLBAR and Gtk::UI_MANAGER_POPUP.

Returns
  A newly-allocated SList of all toplevel widgets of the requested types.

std::vector<const Widget*> Gtk::UIManager::get_toplevels | ( | UIManagerItemType | types | ) | const

Obtains a list of all toplevel widgets of the requested types.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Parameters

  types | Specifies the types of toplevel widgets to include. Allowed types are Gtk::UI_MANAGER_MENUBAR, Gtk::UI_MANAGER_TOOLBAR and Gtk::UI_MANAGER_POPUP.

Returns
  A newly-allocated SList of all toplevel widgets of the requested types.

static GType Gtk::UIManager::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

Glib::ustring Gtk::UIManager::get_ui | ( |  | ) | const

Creates a [UI definition][XML-UI] of the merged UI.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Returns
  A newly allocated string containing an XML representation of the merged UI.

Widget* Gtk::UIManager::get_widget | ( | const Glib::ustring & | path | ) |

Looks up a widget by following a path.

The path consists of the names specified in the XML description of the UI. separated by “/”. Elements which don’t have a name or action attribute in the XML (e.g. <popup>) can be addressed by their XML element name (e.g. "popup"). The root element ("/ui") can be omitted in the path.

Note that the widget found by following a path that ends in a <menu>; element is the menuitem to which the menu is attached, not the menu it manages.

Also note that the widgets constructed by a ui manager are not tied to the lifecycle of the ui manager. If you add the widgets returned by this function to some container or explicitly ref them, they will survive the destruction of the ui manager.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  Use Gtk::Builder::get_widget() instead.

Parameters

  path | A path.

Returns
  The widget found by following the path, or `nullptr` if no widget was found.

const Widget* Gtk::UIManager::get_widget | ( | const Glib::ustring & | path | ) | const

Looks up a widget by following a path.

The path consists of the names specified in the XML description of the UI. separated by “/”. Elements which don’t have a name or action attribute in the XML (e.g. <popup>) can be addressed by their XML element name (e.g. "popup"). The root element ("/ui") can be omitted in the path.

Note that the widget found by following a path that ends in a <menu>; element is the menuitem to which the menu is attached, not the menu it manages.

Also note that the widgets constructed by a ui manager are not tied to the lifecycle of the ui manager. If you add the widgets returned by this function to some container or explicitly ref them, they will survive the destruction of the ui manager.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  Use Gtk::Builder::get_widget() instead.

Parameters

  path | A path.

Returns
  The widget found by following the path, or `nullptr` if no widget was found.

GtkUIManager* Gtk::UIManager::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GtkUIManager* Gtk::UIManager::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GtkUIManager* Gtk::UIManager::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

void Gtk::UIManager::insert_action_group | ( | const Glib::RefPtr< ActionGroup >& | action_group,
|  | int | pos = `0`
| ) |  |

Inserts an action group into the list of action groups associated with manager.

Actions in earlier groups hide actions with the same name in later groups.

If pos is larger than the number of action groups in manager, or negative, action_group will be inserted at the end of the internal list.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  Use Gio::ActionGroup and Gtk::Widget::insert_action_group() instead.

Parameters

  action_group | The action group to be inserted.
  pos | The position at which the group will be inserted.

ui_merge_id Gtk::UIManager::new_merge_id | ( |  | ) |

Returns an unused merge id, suitable for use with gtk_ui_manager_add_ui().

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Returns
  An unused merge id.

virtual void Gtk::UIManager::on_actions_changed | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_actions_changed().

virtual void Gtk::UIManager::on_add_widget | ( | Widget* | widget | ) |
| protectedvirtual

This is a default handler for the signal signal_add_widget().

virtual void Gtk::UIManager::on_connect_proxy | ( | const Glib::RefPtr< Action >& | action,
|  | Widget* | widget
| ) |  |
| protectedvirtual

This is a default handler for the signal signal_connect_proxy().

virtual void Gtk::UIManager::on_disconnect_proxy | ( | const Glib::RefPtr< Action >& | action,
|  | Widget* | widget
| ) |  |
| protectedvirtual

This is a default handler for the signal signal_disconnect_proxy().

virtual void Gtk::UIManager::on_post_activate | ( | const Glib::RefPtr< Action >& | action | ) |
| protectedvirtual

This is a default handler for the signal signal_post_activate().

virtual void Gtk::UIManager::on_pre_activate | ( | const Glib::RefPtr< Action >& | action | ) |
| protectedvirtual

This is a default handler for the signal signal_pre_activate().

UIManager& Gtk::UIManager::operator= | ( | UIManager&& | src | ) |
| noexcept

Glib::PropertyProxy< bool > Gtk::UIManager::property_add_tearoffs | ( |  | ) |

The "add-tearoffs" property controls whether generated menus have tearoff menu items.

Note that this only affects regular menus. Generated popup menus never have tearoff menu items.

Since gtkmm 2.4:

Deprecated: 3.4: Tearoff menus are deprecated and should not be used in newly written code.

Deprecated:
  Tearoff menus are deprecated and should not be used in newly written code.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::UIManager::property_add_tearoffs | ( |  | ) | const

The "add-tearoffs" property controls whether generated menus have tearoff menu items.

Note that this only affects regular menus. Generated popup menus never have tearoff menu items.

Since gtkmm 2.4:

Deprecated: 3.4: Tearoff menus are deprecated and should not be used in newly written code.

Deprecated:
  Tearoff menus are deprecated and should not be used in newly written code.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::UIManager::property_ui | ( |  | ) | const

An XML string describing the merged UI.

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gtk::UIManager::remove_action_group | ( | const Glib::RefPtr< ActionGroup >& | action_group | ) |

Removes an action group from the list of action groups associated with manager.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  Use Gio::ActionGroup and Gtk::Widget::remove_action_group() instead.

Parameters

  action_group | The action group to be removed.

void Gtk::UIManager::remove_ui | ( | ui_merge_id | merge_id | ) |

Unmerges the part of manager's content identified by merge_id.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Parameters

  merge_id | A merge id as returned by gtk_ui_manager_add_ui_from_string().

void Gtk::UIManager::set_add_tearoffs | ( | bool | add_tearoffs = `true` | ) |

Sets the “add_tearoffs” property, which controls whether menus generated by this Gtk::UIManager will have tearoff menu items.

Note that this only affects regular menus. Generated popup menus never have tearoff menu items.

Since gtkmm 2.4:

Deprecated: 3.4: Tearoff menus are deprecated and should not be used in newly written code.

Deprecated:
  Tearoff menus are deprecated and should not be used in newly written code.

Parameters

  add_tearoffs | Whether tearoff menu items are added.

Glib::SignalProxy< void > Gtk::UIManager::signal_actions_changed | ( |  | ) |

Slot Prototype:
  `void on_my_actions_changed()`

Flags: Run First

The signal_actions_changed() signal is emitted whenever the set of actions changes.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Glib::SignalProxy< void,Widget* > Gtk::UIManager::signal_add_widget | ( |  | ) |

Slot Prototype:
  `void on_my_add_widget(Widget* widget)`

Flags: Run First

The signal_add_widget() signal is emitted for each generated menubar and toolbar. It is not emitted for generated popup menus, which can be obtained by gtk_ui_manager_get_widget().

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Parameters

  widget | The added widget.

Glib::SignalProxy< void,const Glib::RefPtr<Action>&,Widget* > Gtk::UIManager::signal_connect_proxy | ( |  | ) |

Slot Prototype:
  `void on_my_connect_proxy(const Glib::RefPtr<Action>& action, Widget* widget)`

Flags: Run First

The signal_connect_proxy() signal is emitted after connecting a proxy to an action in the group.

This is intended for simple customizations for which a custom action class would be too clumsy, e.g. showing tooltips for menuitems in the statusbar.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Parameters

  action | The action.
  widget | The proxy.

Glib::SignalProxy< void,const Glib::RefPtr<Action>&,Widget* > Gtk::UIManager::signal_disconnect_proxy | ( |  | ) |

Slot Prototype:
  `void on_my_disconnect_proxy(const Glib::RefPtr<Action>& action, Widget* widget)`

Flags: Run First

The signal_disconnect_proxy() signal is emitted after disconnecting a proxy from an action in the group.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Parameters

  action | The action.
  widget | The proxy.

Glib::SignalProxy< void,const Glib::RefPtr<Action>& > Gtk::UIManager::signal_post_activate | ( |  | ) |

Slot Prototype:
  `void on_my_post_activate(const Glib::RefPtr<Action>& action)`

Flags: Run First

The signal_post_activate() signal is emitted just after the action is activated.

This is intended for applications to get notification just after any action is activated.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Parameters

  action | The action.

Glib::SignalProxy< void,const Glib::RefPtr<Action>& > Gtk::UIManager::signal_pre_activate | ( |  | ) |

Slot Prototype:
  `void on_my_pre_activate(const Glib::RefPtr<Action>& action)`

Flags: Run First

The signal_pre_activate() signal is emitted just before the action is activated.

This is intended for applications to get notification just before any action is activated.

Since gtkmm 2.4:

Deprecated: 3.10

Deprecated:
  There is no corresponding replacement when using Gtk::Builder.

Parameters

  action | The action.

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::UIManager > wrap | ( | GtkUIManager * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.